/* --------------------------- *\
    RGB LED Control with PASM
    -- bashed up by JonnyMac
    -- you've been warned...
\* --------------------------- */


#include <stdio.h>
#include <propeller.h>

static unsigned int rgbcolor;                         // required for RGB pwm
static unsigned int rpin; 
static unsigned int gpin;
static unsigned int bpin;

int start(unsigned int *color)                        // start RGB cog
{
  extern unsigned int binary_rgbled_dat_start[];
  return cognew(&binary_rgbled_dat_start, color);
}

void set_rgb(int r, int g, int b)                     // set color from rgb bytes
{
  rgbcolor  = (r & 0xff) << 16;
  rgbcolor |= (g & 0xff) << 8;
  rgbcolor |= (b & 0xff);
}

int main(void)
{
  int level;

  rpin = 18;
  gpin = 17;
  bpin = 16;
  start(&rgbcolor);

  while (1) {
    for (level = 0x00; level <= 0xFF; level++) {
      set_rgb(level, 0x00, 0x00);
      waitcnt(CNT + (CLKFREQ >> 7));
    }

    for (level = 0x00; level <= 0xFF; level++) {
      set_rgb(0x00, level, 0x00);
      waitcnt(CNT + (CLKFREQ >> 7));
    }

    for (level = 0x00; level <= 0xFF; level++) {
      set_rgb(0x00, 0x00, level);
      waitcnt(CNT + (CLKFREQ >> 7));
    }

  }
}

